/* This version works like logon.c on UNIX systems */

/*
 * LOGON.C (A QUANTUM HACK 12/19/89)
 * Copyright(?) Nope.
 * Spread this around and alter all you wish.
 *
 *
 * History:
 * 12/28/89 * Added Ansi picture of month & day
 *
 * General Pupose logon event program for BBS's or other systems.
 *
 *  usage: logon [path]
 *
 *  logon does the following:
 *
 *    1) "Types" out file hear-ye.txt
 *
 *    2) Randomly picks out one line of text from file fortunes.txt
 *
 *    3) Searches motd.txt for line(s) matching current month and
 *       day (format MM:DD) and prints out next text found between
 *       C-language like comments (each on a line by themselves).
 *
 *    4) Checks to see if it can read a file named after the the
 *       current MONTH and DAY in the format MMDD.ans .
 *       If it can then it will ask whether or not the user
 *       would like to see it typed to screen. If it does not exist
 *       then nothing is done.
 *
 *    5) Checks to see if it can read a file named after the the
 *       current MONTH in the format MM00.ans .
 *       If it can then it will ask whether or not the user
 *       would like to see it typed to screen. If it does not exist
 *       then nothing is done.
 *
 *    6) Type out files named hear_ye.hdr, fortunes.hdr and motd.hdr
 *       prior to the hear ye, fortune and message of the day respectively.
 *
 *    if the data files are in another directory then that directorys path
 *    name may be specified on the command line. ex. logon other_dir/
 *
 */

#include <stdio.h>
#include <time.h>
#include <signal.h>
#include <termio.h>

#define MAXLINE 512

static	struct termio nttybuf;
static	struct termio rttybuf;

char line[500];
char bline[500];

main(argc,argv)
int argc;
char *argv[];
{

	FILE *fp;
	char c;
	char month[10];
	char day[10];

	char directory[80]; /* directory where below are located */
	/* headers */
	char hear_ye_hdr[80]; /* announcement file */
	char fortunes_hdr[80]; /* fortune file */
	char motd_hdr[80]; /* message of the day */
	/* data files */
	char hear_ye[80]; /* announcement file */
	char fortunes[80]; /* fortune file */
	char motd[80]; /* message of the day */
	char potm[80]; /* picture of the month */
	char potd[80]; /* picture of the day */

	extern int res_tty();

	if(ioctl (0, TCGETA, &nttybuf) < 0) {
		perror ("ioctl 1 failed\n");
		exit(1);
	}
	signal(SIGINT, res_tty);
	signal(SIGQUIT, res_tty);
	rttybuf = nttybuf;	/* RAW like NORM, except as below */
	rttybuf.c_lflag &= ~ICANON;		/* raw mode */
	rttybuf.c_line = 0;			/* Line dscpl 0 */
	rttybuf.c_cc[VMIN] = (unsigned char)1;	/* single char read */
	if (ioctl (0, TCSETAW, &rttybuf) < 0) {
		perror ("ioctl 2 failed\n");
		exit(1);
	}

	strcpy(directory,"");
	if (argc > 1) {
		strcat(directory,argv[1]);
	}

	strcpy(hear_ye_hdr,directory);
	strcpy(fortunes_hdr,directory);
 	strcpy(motd_hdr,directory);
	strcpy(hear_ye,directory);
	strcpy(fortunes,directory);
 	strcpy(motd,directory);
	strcpy(potm,directory);
	strcpy(potd,directory);

	strcat(hear_ye_hdr,"hear_ye.hdr");
	strcat(fortunes_hdr,"fortunes.hdr");
	strcat(motd_hdr,"motd.hdr");
	strcat(hear_ye,"hear_ye.txt");
	strcat(fortunes,"fortunes.txt");
	strcat(motd,"motd.txt");

	/* Current Announcements */
	type(hear_ye_hdr);
	if (type(hear_ye) != NULL) {
 		fprintf(stderr,"logon: can't read \"%s\"\n",hear_ye);
	}

	/* Random fortune or proverb */
	type(fortunes_hdr);
	if (fortune(fortunes) != NULL) {
 		fprintf(stderr,"logon: can't read \"%s\"\n",fortunes);
	}

	/* Message of the day */
	if (onthisday(motd,month,day,motd_hdr) != NULL) {
 		fprintf(stderr,"logon: can't read \"%s\"\n",motd);
	}

	/* Picture of the Month, Ansi or Regular text */
 	strcat(potm,month);
 	strcat(potm,"00");
	if (okansi) {
		strcat(potm,".ans");
	}
	else {
		strcat(potm,".msg");
	}

	if ((fp=fopen(potm, "r")) != NULL ){
		fclose(fp);

		printf("\n\007Do you want to see the ANSI picture of the month?\n");
		while (1) {
		printf("\r[y]es or [n]o : ");
			read(0, INPUTc, 1);
			switch (tolower(c)) {
				case 'y':
					printf("\b Yes\n");
					type(potm);
					break;
				case 'n':
					printf("\b No\n");
					break;
				default:
					continue;
			}
			break;
		}
	}



	/* Picture of the day, Ansi or Regular text */
 	strcat(potd,month);
 	strcat(potd,day);
	if (okansi) {
		strcat(potd,".ans");
	}
	else {
		strcat(potd,".msg");
	}

	if ((fp=fopen(potd, "r")) != NULL ){
		fclose(fp);
		printf("\n\007Do you want to see the ANSI picture of the day?\n");
		while (1) {
		printf("\r[y]es or [n]o : ");
			read(0, INPUTc, 1);
			switch (tolower(c)) {
				case 'y':
					printf("\b Yes\n");
					type(potd);
					break;
				case 'n':
					printf("\b No\n");
					break;
				default:
					continue;
			}
			break;
		}
	}
#ifdef __UNIX__
res_tty();
#endif
}


fortune(f)
char *f;
{
	double p, pow();
	register char * l;
	long t;
	FILE *fp;

	if ((fp = fopen(f, "r")) == NULL ){
		return(1);
	}

	time(&t);
	srand((int)((t>>16) + t));
	p = 1.;
	for(;;) {
		l = fgets(line, 500, fp);
		if(l == NULL) {
			break;
		}
		if(rand() < 32767/p) {
			strcpy(bline, line);
		}
		p += 1.;
	}
	printf("%s",bline);
	return(0);
}

onthisday(f,m,d,h)
char *f;
char m[];
char d[];
char h[];
{

	FILE *fp;
	int month,day;
	short flag;
	char line[MAXLINE];
	char today[10];
	long T;
	struct tm *tp;

	if ((fp = fopen(f, "r")) == NULL ){
		return(1);
	}

	T = time( (long *)0 );
	tp = localtime(&T);
	month=tp->tm_mon+1;
	day=tp->tm_mday;
	sprintf(m,"%02d",month);
	sprintf(d,"%02d",day);

  	sprintf(today,"%02d:%02d\n",month,day);
	flag=0;
	while (fgets(line,MAXLINE,fp) !=NULL ) {

		if ( strcmp(line,today) == NULL) {
			type(h);			
			flag=1;
			continue;
		}

		if ( strcmp(line,"/*\n") == NULL) {
			continue;
		}

		if ( strcmp(line,"*/\n") == NULL) {
			flag=0;
		}

		if ( flag == 1) {
			printf("%s",line);
		}
	}
	fclose(fp);
	return(0);
}

type(f)
char *f;
{
	int c;
	FILE *fp;

	if ((fp = fopen(f, "r")) == NULL) {
/* 		fprintf(stderr,"logon: can't read \"%s\"\n",f); */
		return(1);
	}
	else {
		while (( c = fgetc(fp)) != EOF) {
			fputc(c,stdout);
		}
		fclose(fp);
	}
	return(0);
}


res_tty()
{
	ioctl (0, TCSETAW, &nttybuf);
}

